jQuery(document).ready(() => {
  let finalStoredArray = JSON.parse(localStorage.getItem('items'));
  
  let register = (i) => {
    // block icon
    const iconEl = wp.element.createElement("svg", {
        version: "1.0",
        xmlns: "http://www.w3.org/2000/svg",
        width: "71.000000pt",
        height: "114.000000pt",
        viewBox: "0 0 71.000000 114.000000",
        preserveAspectRatio: "xMidYMid meet"
      }, wp.element.createElement("metadata", null, "Created by potrace 1.10, written by Peter Selinger 2001-2011"), wp.element.createElement("g", {
        transform: "translate(0.000000,114.000000) scale(0.050000,-0.050000)",
        fill: "#f27431",
        stroke: "none"
      }, wp.element.createElement("path", {
        d: "M476 2262 c-73 -27 -243 -297 -328 -521 -203 -534 -98 -1230 249\n-1652 151 -185 286 -32 148 167 -386 552 -386 1216 1 1770 105 150 65 286 -70\n236z"
      }), wp.element.createElement("path", {
        d: "M756 1945 c-326 -373 -352 -1081 -58 -1524 85 -128 118 -151 189\n-134 91 23 89 95 -5 240 -235 360 -243 806 -22 1189 44 76 80 152 80 170 0 83\n-127 124 -184 59z"
      }), wp.element.createElement("path", {
        d: "M1089 1647 c-183 -198 -182 -737 2 -1029 103 -162 249 -70 170 108\n-68 154 -101 289 -101 414 0 103 11 157 83 397 25 83 24 89 -21 125 -61 50\n-75 48 -133 -15z"
    })));

    let src = '';

    for(let [key, value] of Object.entries(finalStoredArray[i].features)) {
      if(value == 0 || value == 1) {
        src += `${key}:${value},`;
      }
    }

    wp.blocks.registerBlockType('ipcamlive/ipcamliveblock'+i,{
        title: `IPCamLive-${finalStoredArray[i].alias}`,
        icon: iconEl,
        category: 'media',
        attributes: {
          style: {
            width: {
              type: 'string',
              source: 'attribute',
              default: '100%',
            },
            height: {
              type: 'string',
              source: 'attribute',
              default: '56.25%',
            },
            aspectRatio: {
              default: 1,
            }
          },
          src: {
            type: 'string',
            source: 'attribute',
            default: 'https://ipcamlive.com/player/snapshot.php?alias='+finalStoredArray[i].alias,
          },
          'data-status': {
            type: 'boolean',
            source: 'attribute',
            default: false,
          }
        },

        edit: function(props){
          
          if ( finalStoredArray[i].aspect_ratio >= 1 ) {
            props.setAttributes({width: `${finalStoredArray[i].box_width * 100}%`, height: '100%', aspectRatio: finalStoredArray[i].box_width});
          } else {
            props.setAttributes({height: `${finalStoredArray[i].aspect_ratio * 100}%`, width: '100%', aspectRatio: finalStoredArray[i].aspect_ratio});
          }

          function urlExists(url) {
            fetch(url)
            .then(async (data) => {
              if(data.ok) {
                props.setAttributes({'data-status': true});
                console.clear();
              } else {
                props.setAttributes({'data-status': false});
                console.clear();
              }
            })
          }

          let url = props.attributes.src;
          urlExists(url);

          if(props.attributes['data-status']) {

            return wp.element.createElement('img', {
              src: props.attributes.src,
              'width': props.attributes.width,
              'height': props.attributes.height,
              style: {
                'display': 'block',
                'marginLeft': 'auto',
                'marginRight': 'auto',
              },
            });
          } else {
            return wp.element.createElement('div', {
                style:{
                  'display': 'flex',
                  'justifyContent': 'center',
                  'width': finalStoredArray[i].cameraWidth,
                  'height': finalStoredArray[i].cameraHeight,
                  'aspectRatio': props.attributes.aspectRatio,
                }
              },
              wp.element.createElement('div', {
                  style:{
                    'aspectRatio': props.attributes.aspectRatio,
                    'background': 'black',
                    'position': 'relative',
                    'maxHeight': '650px',
                  }
                },
                wp.element.createElement('p', {
                  style: {
                    'display': 'flex',
                    'positon': 'absolute',
                    'top': 0,
                    'left': 0,
                    'height': '100%',
                    'justifyContent': 'center',
                    'alignItems': 'center',
                    'color': 'white',
                    'textAlign': 'center',
                  }
                },
                  wp.element.createElement('img', {
                    'src': js_data.icon,
                    'width': 30,
                    'height': 30,
                  }),
                  'Camera is not available'
                )
              )
            );
          }
        },

        example: function(){},

        save: function(){
          return `[ipcamlive_load_camera alias="${finalStoredArray[i].alias}" features="${src}" aspectratio = "${finalStoredArray[i].aspect_ratio}" boxwidth = "${finalStoredArray[i].box_width}"]`;
        }
    });
  };

  for(let i=0; i < finalStoredArray.length; i++) {
    register(i);
  }
})